# -*- coding: UTF-8 -*-
'''
	Copyright zmofun           All rights reserved!
	http://www.zmofun.com
	2000.1.14        TurboC++2.0

  zmofun@163.com
  2022.1.29    移植到PYTHON TKINTER版本
'''
# python2:
# import Tkinter as tk
# import tkMessageBox as messagebox

# python3:
import tkinter as tk
from tkinter import messagebox

import random
import time
import copy
import ctypes


class Shape:
    # shapeall[9][25]
    shapeall = [[
        0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0
    ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0,
                    0, 0, 1, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0,
                    0, 0, 0, 0, 0
                ]]

    def __init__(self, canvas, nextx, nexty):
        self.canvas = canvas
        self.nextx = nextx
        self.nexty = nexty

    def getnextsh(self, x, y, il, ic, level):
        no, i = 0, 0
        self.no = random.randint(0, 6 - 1) + level
        self.px = x
        self.py = y
        self.l = il
        self.c = ic
        for i in range(0, 25):
            self.s[i // 5][i % 5] = self.b[i // 5][i % 5]
            self.b[i // 5][i % 5] = Shape.shapeall[self.no][i]

        for i in range(0, 5):
            for j in range(0, 5):
                self.canvas.delete(self.srect[i][j])
                if self.s[i][j]:
                    self.srect[i][j] = self.canvas.create_rectangle(
                        self.px + j * (self.width // 5) + 1,
                        self.py + i * (self.width // 5) + 1,
                        self.px + (j + 1) * (self.width // 5) - 1,
                        self.py + (i + 1) * (self.width // 5) - 1,
                        fill="blue",
                        outline="yellow",
                        width=1)

                self.canvas.delete(self.brect[i][j])
                if self.b[i][j]:
                    self.brect[i][j] = self.canvas.create_rectangle(
                        self.nextx + j * (self.width // 5) + 1,
                        self.nexty + i * (self.width // 5) + 1,
                        self.nextx + (j + 1) * (self.width // 5) - 1,
                        self.nexty + (i + 1) * (self.width // 5) - 1,
                        fill="blue",
                        outline="yellow",
                        width=1)

        return 0

    def init(self, x, y, w, il, ic, level):
        self.px = x
        self.py = y
        self.l = il
        self.c = ic
        self.width = w
        self.s = [([0] * 5) for i in range(5)]
        self.b = [([0] * 5) for i in range(5)]
        self.t = [([0] * 5) for i in range(0, 5)]
        self.l, self.c = 0, 0
        self.srect = [([0] * 5) for i in range(5)]
        self.brect = [([0] * 5) for i in range(5)]
        self.trect = [([0] * 5) for i in range(5)]

        self.getnextsh(x, y, il, ic, level)

        return 0

    def rotate(self):
        i, j = 0, 0

        for i in range(0, 5):
            for j in range(0, 5):
                self.t[i][j] = self.s[i][j]
                self.trect[i][j] = self.srect[i][j]

        self.erase()
        for i in range(0, 5):
            for j in range(0, 5):
                self.s[i][j] = self.t[4 - j][i]
                self.srect[i][j] = self.trect[4 - j][i]
                if self.s[i][j]:
                    self.canvas.move(self.srect[i][j],
                                     (j - i) * self.width // 5,
                                     (i - 4 + j) * self.width // 5)
                    '''
                    self.srect[i][j] = self.canvas.create_rectangle(
                        self.px + j * (self.width // 5) + 1,
                        self.py + i * (self.width // 5) + 1,
                        self.px + (j + 1) * (self.width // 5) - 1,
                        self.py + (i + 1) * (self.width // 5) - 1,
                        fill="blue",
                        outline="yellow",
                        width=1)
                    '''
        self.paint()

        return 0

    def paint(self):
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                '''
                if self.s[i][j]:
                    self.canvas.create_rectangle(
                        self.px + j * (self.width // 5) + 1,
                        self.py + i * (self.width // 5) + 1,
                        self.px + (j + 1) * (self.width // 5) - 1,
                        self.py + (i + 1) * (self.width // 5) - 1,
                        fill="blue",
                        outline="yellow",
                        width=1)
                '''

        return 0

    def paintnext(self, x, y):
        i, j = 0, 0
        '''
        self.canvas.create_rectangle(x,
                                     y,
                                     x + self.width,
                                     y + self.width,
                                     fill="blue",
                                     outline="blue",
                                     width=1)
        for i in range(0, 5):
            for j in range(0, 5):
                if self.b[i][j]:
                    self.canvas.create_rectangle(
                        x + j * (self.width // 5) + 1,
                        y + i * (self.width // 5) + 1,
                        x + (j + 1) * (self.width // 5) - 1,
                        y + (i + 1) * (self.width // 5) - 1,
                        fill="blue",
                        outline="yellow",
                        width=1)
        '''
        return 0

    def erase(self):
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                if self.s[i][j]:
                    '''
                    self.canvas.create_rectangle(
                        self.px + j * (self.width // 5) + 0,
                        self.py + i * (self.width // 5) + 0,
                        self.px + (j + 1) * (self.width // 5) - 0,
                        self.py + (i + 1) * (self.width // 5) - 0,
                        fill="blue",
                        outline="blue",
                        width=1)
                    '''
                    #self.canvas.delete(self.srect[i][j])
                    return 0
        return 0

    def move(self, direct):
        self.erase()
        if direct == 1:
            self.px = self.px - self.width // 5
            self.c = self.c - 1
            for i in range(0, 5):
                for j in range(0, 5):
                    if self.s[i][j]:
                        self.canvas.move(self.srect[i][j], -self.width // 5, 0)
        elif direct == 2:
            self.px = self.px + self.width // 5
            self.c = self.c + 1
            for i in range(0, 5):
                for j in range(0, 5):
                    if self.s[i][j]:
                        self.canvas.move(self.srect[i][j], self.width // 5, 0)
        else:
            self.py = self.py + self.width // 5
            self.l = self.l + 1
            for i in range(0, 5):
                for j in range(0, 5):
                    if self.s[i][j]:
                        self.canvas.move(self.srect[i][j], 0, self.width // 5)
        self.paint()
        return 0


class GameBox:
    def __init__(self, canvas):
        self.canvas = canvas

    def init(self, x, y, boxw, w, h, messx, keyin):
        self.stick = [([0] * 22) for i in range(41)]
        self.sstick = [([0] * 22) for i in range(41)]
        self.px = x
        self.py = y
        self.boxwidth = boxw
        self.boxperline = w
        self.boxpercolumn = h
        self.pxmess = messx
        self.level = 1
        self.levelmess = None
        self.score = 0
        self.scoremess = None
        self.speed = 1
        self.speedmess = None
        self.layer = 3
        self.layermess = None
        self.inter = time.time()
        self.begin = 0
        for i in range(0, self.boxpercolumn):
            for j in range(1, self.boxperline + 1):
                self.stick[i][j] = 0
        for i in range(0, self.boxpercolumn):
            self.stick[i][0] = 1
            self.stick[i][self.boxperline + 1] = 1

        for j in range(0, self.boxperline + 2):
            self.stick[self.boxpercolumn][j] = 1

        #外框
        self.canvas.create_rectangle(
            self.px - 1,
            self.py - 1,
            self.px + self.boxperline * self.boxwidth + 1,
            self.py + self.boxpercolumn * self.boxwidth + 1,
            fill="blue",
            outline="yellow",
            width=1)
        self.__initmessage()

        self.controlkey = keyin
        self.__paint()
        self.curshape = Shape(self.canvas, self.pxmess - 15, self.py + 200)
        self.curshape.init(
            self.px + self.boxwidth * (self.boxperline // 2 - 2), self.py,
            5 * self.boxwidth, 0, self.boxperline // 2 - 2, self.level)



    def __gamebegin(self):
        i, j, b = 0, 0, 0
        randnum = [
            1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0,
            1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1,
            0, 1, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0,
            1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0,
            1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0,
            0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1,
            0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 0, 1,
            0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0,
            1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1,
            0, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0,
            0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1,
            0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 0, 0, 1,
            0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0,
            0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0,
            1, 0
        ]

        for i in range(0, self.boxpercolumn - 1):  # clear game box's stick
            for j in range(1, self.boxperline + 1):
                self.stick[i][j] = 0

        for i in range(0, self.layer):
            for j in range(1, self.boxperline + 1):
                b = random.randint(0, 20 - 1) + i
                self.stick[self.boxpercolumn - 1 - i][j] = randnum[b + j]
                if self.stick[i][j]:
                    self.sstic[i][j] = self.canvas.create_rectangle(
                        self.px + self.boxwidth * (j - 1) + 1,
                        self.py + self.boxwidth * i + 1,
                        self.px + self.boxwidth * j - 1,
                        self.py + self.boxwidth * (i + 1) - 1,
                        fill="blue",
                        outline="yellow",
                        width=1)

        self.__paintstick()
        self.curshape.getnextsh(
            self.px + self.boxwidth * (self.boxperline // 2 - 3), self.py, 0,
            self.boxperline // 2 - 2, self.level)
        self.curshape.paint()
        self.curshape.paintnext(self.pxmess - 15, self.py + 200)
        self.score = 0
        self.__showscore()
        self.begin = 1
        return 0

    def __gameconfiged(self, key):
        if not key:
            return 0
        if key == self.controlkey[0]:
            self.level = (self.level + 1) % 4
        if key == self.controlkey[1]:
            return 1
        if key == self.controlkey[2]:
            self.speed = (self.speed + 1) % 10
        if key == self.controlkey[3]:
            self.layer = (self.layer + 1) % 10
        self.__showmessage()
        return 0

    def __initmessage(self):
        mess = [' '] * 5
        # settextstyle(0, 0, 1);
        self.canvas.create_text(self.px + 100,
                                460,
                                text="http://www.zmofun.com",
                                fill="yellow")
        self.canvas.create_text(self.pxmess,
                                self.py + 20,
                                text="LEVEL",
                                fill="yellow")

        self.canvas.create_text(self.pxmess,
                                self.py + 60,
                                text="SPEED",
                                fill="yellow")

        self.canvas.create_text(self.pxmess,
                                self.py + 100,
                                text="LAYER",
                                fill="yellow")
        self.__showscore()
        return 0

    def __showmessage(self):
        mess = [' '] * 5

        mess = "%d" % self.level
        self.canvas.delete(self.levelmess)
        self.levelmess = self.canvas.create_text(self.pxmess + 20 + 6,
                                                 self.py + 40 + 2,
                                                 text=mess,
                                                 fill="yellow")
        mess = "%d" % self.speed
        self.canvas.delete(self.speedmess)
        self.speedmess = self.canvas.create_text(self.pxmess + 20 + 6,
                                                 self.py + 80 + 2,
                                                 text=mess,
                                                 fill="yellow")
        mess = "%d" % self.layer
        self.canvas.delete(self.layermess)
        self.layermess = self.canvas.create_text(self.pxmess + 20 + 6,
                                                 self.py + 120 + 2,
                                                 text=mess,
                                                 fill="yellow")
        self.__showscore()
        return 0

    def __showscore(self):
        mess = [' '] * 8
        # settextstyle(0, 0, 1);
        mess = "%d" % self.score
        self.canvas.delete(self.scoremess)
        self.scoremess = self.canvas.create_text(self.px + 50 + 6,
                                                 self.py - 20 + 2,
                                                 text=mess,
                                                 fill="yellow")
        return 0

    def __addscore(self):
        i, j, line, ln, high, addspeed = 0, 0, 0, 0, 0, 0
        t = [0] * 40
        self.line = 0
        for i in range(self.boxpercolumn - 1, -1, -1):
            t[i] = 0
            for j in range(1, self.boxperline + 1):
                t[i] += self.stick[i][j]
            if t[i]:
                self.high = i
            if t[i] == self.boxperline:
                line = line + 1
                t[i] = 1
            else:
                t[i] = 0
        for i in range(self.boxpercolumn - 1, high - 1, -1):
            if t[i]:
                ln = i - 1
                while t[ln]:
                    ln = ln - 1
                for j in range(1, self.boxperline + 1):
                    self.stick[i][j] = self.stick[ln][j]
                    self.stick[ln][j] = 0
                t[ln] = 1
        self.__paintstick()
        addspeed = self.score // 1000
        if line > 3:
            self.score += 2 * line * 100
        else:
            self.score += line * 100
        if addspeed != self.score // 1000:
            self.speed = (self.speed + 1) % 10
        self.__showscore()
        return 0

    def __paint(self):
        self.__showmessage()
        return 0

    def __paintstick(self):
        i, j = 0, 0

        for i in range(0, self.boxpercolumn):
            for j in range(1, self.boxperline + 1):
                self.canvas.delete(self.sstick[i][j])
                if self.stick[i][j]:
                    self.sstick[i][j] = self.canvas.create_rectangle(
                        self.px + self.boxwidth * (j - 1) + 1,
                        self.py + self.boxwidth * i + 1,
                        self.px + self.boxwidth * j - 1,
                        self.py + self.boxwidth * (i + 1) - 1,
                        fill="blue",
                        outline="yellow",
                        width=1)
                '''    
                else:
                    self.canvas.create_rectangle(
                        self.px + self.boxwidth * (j - 1) + 1,
                        self.py + self.boxwidth * i + 1,
                        self.px + self.boxwidth * j - 1,
                        self.py + self.boxwidth * (i + 1) - 1,
                        fill="blue",
                        outline="blue",
                        width=1)
                '''
        return 0

    def __gameover(self):
        i, j = 0, 0
        if self.curshape.l < 1:
            return 1
        else:
            for i in range(0, 5):
                for j in range(0, 5):
                    if self.curshape.s[i][j]:
                        self.stick[i +
                                   self.curshape.l][self.curshape.c +
                                                    j] = self.curshape.s[i][j]
        self.__addscore()
        return 0

    def __canmove(self, direct):
        i, j = 0, 0
        if direct == 1:
            for j in range(0, 5):
                for i in range(0, 5):
                    if self.curshape.s[i][j] and self.stick[
                            self.curshape.l + i][self.curshape.c - 1 + j]:
                        return 0
        elif direct == 2:
            for j in range(4, -1, -1):
                for i in range(0, 5):
                    if self.curshape.s[i][j] and self.stick[
                            self.curshape.l + i][self.curshape.c + 1 + j]:
                        return 0
        elif direct == 3:
            for i in range(4, -1, -1):
                for j in range(0, 5):
                    if self.curshape.s[i][j] and self.stick[
                            self.curshape.l + 1 + i][self.curshape.c + j]:
                        return 0
        return 1

    def __canrotate(self):
        i, j = 0, 0
        self.t = [([0] * 5) for i in range(0, 5)]
        for i in range(0, 5):
            for j in range(0, 5):
                self.t[i][j] = self.curshape.s[4 - j][i]
                if self.t[i][j] and self.stick[self.curshape.l +
                                               i][self.curshape.c + j]:
                    return 0
        return 1

    def play(self, key):
        if not self.begin:
            if self.__gameconfiged(key):
                self.__gamebegin()
            return 0
        if key == self.controlkey[0]:
            if self.__canrotate():
                self.curshape.rotate()
        if key == self.controlkey[2]:
            if self.__canmove(1):
                self.curshape.move(1)
        if key == self.controlkey[3]:
            if self.__canmove(2):
                self.curshape.move(2)
        if key == self.controlkey[1]:
            if self.__canmove(3):
                self.curshape.move(3)
        if (time.time() - self.inter) * 100 > (160 - 10 * self.level -
                                               10 * self.speed):
            if self.__canmove(3):
                self.inter = time.time()
                self.curshape.move(3)
            else:
                if self.__gameover():
                    self.begin = 0
                else:
                    self.curshape.getnextsh(
                        self.px + self.boxwidth * (self.boxperline // 2 - 3),
                        self.py, 0, self.boxperline // 2 - 2, self.level)
                    self.curshape.paintnext(self.pxmess - 10, self.py + 200)


class Game:
    def __init__(self):
        keya = [87, 83, 65, 68]  # 上下左右w, s, a, d
        keyb = [38, 40, 37, 39]  # 上下左右up, down, left, right

        self.win = tk.Tk()
        self.win.title("Erase")
        self.canvas = tk.Canvas(self.win,
                                width=640,
                                height=480,
                                background="blue")
        #解决方块移动时拖影问题
        #告诉操作系统使用程序自身的dpi适配
        ctypes.windll.shcore.SetProcessDpiAwareness(1)
        #获取屏幕的缩放因子
        scaleFactor = ctypes.windll.shcore.GetScaleFactorForDevice(1)
        #设置程序缩放
        self.win.call('tk', 'scaling', scaleFactor / 100)

        #以下居中显示窗口
        width = 640
        height = 480
        scr_width = self.win.winfo_screenwidth() * scaleFactor // 100
        scr_height = self.win.winfo_screenheight() * scaleFactor // 100
        print(scr_width, scr_height)
        size_position = f'{width}x{height}+{(scr_width-width-16)//2}+{(scr_height-height-32)//2}'
        print(size_position)
        self.win.geometry(size_position)

        self.canvas.grid(row=0, column=0)
        self.canvas.pack()
        self.box = [GameBox(self.canvas), GameBox(self.canvas)]
        self.box[0].init(105, 50, 13, 16, 30, 40, keya)
        self.box[1].init(322, 50, 13, 16, 30, 560, keyb)

        self.canvas.focus_set()  # 聚焦到canvas画板对象上
        self.canvas.bind("<Left>", self.game_keypress)
        self.canvas.bind("<Right>", self.game_keypress)
        self.canvas.bind("<Up>", self.game_keypress)
        self.canvas.bind("<Down>", self.game_keypress)
        self.canvas.bind("<KeyPress-a>", self.game_keypress)
        self.canvas.bind("<KeyPress-d>", self.game_keypress)
        self.canvas.bind("<KeyPress-w>", self.game_keypress)
        self.canvas.bind("<KeyPress-s>", self.game_keypress)
        self.canvas.bind("<Escape>", self.esc)

    def game_keypress(self, event):
        if event.keycode in self.box[0].controlkey:
            self.box[0].play(event.keycode)
        if event.keycode in self.box[1].controlkey:
            self.box[1].play(event.keycode)

    def game_loop(self):
        if self.box[0].begin:
            self.box[0].play(1)
        if self.box[1].begin:
            self.box[1].play(1)
        self.win.after(100, self.game_loop)

    def esc(self, event):
        self.win.destroy()
        exit(0)

    def close(self):
        self.win.destroy()
        exit(0)

    def run(self):
        self.win.update()
        self.win.after(100, self.game_loop)
        self.win.protocol("WM_DELETE_WINDOW", self.close)
        self.win.mainloop()


mygame = Game()
mygame.run()
